%%-------------------------------------------------------------------------
% Main code for chapter 9:Modelling Heteroscedasticity and non-normality 
%--------------------------------------------------------------------------

% -------------- Room saving ----------------------------------------------

close all; clear all; clc; pause(0.01), randn('seed',sum(clock)), rand('seed',sum(clock)), warning off
TSTART = tic;
% -------------- Load folders ---------------------------------------------

addpath([pwd '\Input\']);
addpath([pwd '\Utilities\']);
addpath([pwd '\Output\']);

% -------------- Import data ----------------------------------------------

[data,textdata,raw] = xlsread('STOCKINT2013.xls','Daily');
%[filename,pathname]=uigetfile('*.xls');
%[data,textdata,raw] = xlsread(filename,'Monthly');
%Convert dates into a serial number
date=datenum(textdata(4:end,1),'dd/mm/yyyy');
% Data Transformation BUILDING RETURNS 
run ch9_datatran

%% ------------------------------------------------------------------------
% ---------------- Plot of returns and cumulative returns -----------------
% -------------------------------------------------------------------------
s_start   = '02/01/2006';
s_end     = '30/06/2008';
s_end_os = '31/12/2009';
date_find = datenum([s_start; s_end;s_end_os],'dd/mm/yyyy');
ss        = datefind(date_find(1,1),date);
se        = datefind(date_find(2,1),date);
se_os     = datefind(date_find(3,1),date);
T=se-ss+1;
Tfor=se_os-se;

%-----------  Historical  Returns Matrix ----------------------------
RET=NaN(rows(GER.Stock.Ret),3);
RET(ss:se_os,:) = [GER.Stock.Ret(ss:se_os) UK.Stock.Reteu(ss:se_os) US.Stock.Reteu(ss:se_os)];
w= [0.4 0.3 0.3];
Port=RET*w';
R= [RET(ss:se_os,:) Port(ss:se_os,:)];
RSQ=R.^2;
Perf = cumsum(R);
% Plot returns squared return and cumulative returns 
run Figure001 
%% ------------------------------------------------------GARCH ------------------
% Benchmark GARCH estimation (ss:se) and forecast(se+1:se_os)
% -------------------------------------------------------------------------
run Ch9_s1_garch.m

%% ------------------------------------------------------------------------
%  Riskmetrics Variance estimation (ss:se) and forecast(se+1:se_os)
%--------------------------------------------------------------------------
run Ch9_s2_es.m

% Plot GARCH vs RiskMetrics within sample
run Figure002.m

% Plot GARCH vs ES fitted out-of-sample conditional variances
run Figure003.m
%Vars
disp(' VaR Forecasting under Alternative Models se+1:se_os')
% Daily VaR - 99% confidence level
alpha=0.01;
Var_garch=norminv(alpha,0,garch_1s_for);
Var_es=norminv(alpha,0,es_std_1s_for);

% Plot Daily VaRs and Returns
run Figure004.m 
%--------------------------------------------------------------------------
%% compare GARCH versus RISKMETRICS SIMULATED SERIES 
run Ch9_s3_GARCHvsES.m
%--------------------------------------------------------------------------
%% COMPARE GARCH with more sophisticated variance estimates sample se:ss
run Ch9_s4.m
%--------------------------------------------------------------------------
%Regression analysis of performance of GARCH, ES, NG models
run Ch9_s5.m
%--------------------------------------------------------------------------
%NORMALITY of Returns and standardized returns 
%--------------------------------------------------------------------------
run Ch9_s6_norm.m
%% Computing Value at Risk under Alternative Volatility Models
run Ch9_s7_VaR.m
%% QMLE vs. MLE for NGARCH standardized t(d) model
run Ch9_s8_QMLEvsMLE.m

%% Estimates of the EVT model using the Hill estimator.
run Ch9_s9_EVT.m

tElapsed = toc(TSTART);
display(['The time needed to run the code is: ',num2str(tElapsed/60),' minutes']);         










