disp('======================== GARCH(1,1) Estimation ==========================')

% Estimation is perfomed using the command garchfit
spec=garchset('P',1,'Q',1);                                                 %garchset sets the ARMAX/GARCH model specification parameters
[coeff, errors,llf,innovation,GARCHsigma,summary]=garchfit(spec,Port(ss:se,:));
                                                                            %garchfit estimates ARMAX/GARCH model parameters with format
garchdisp(coeff,errors);

%garchdisp displays ARMAX/GARCH model parameters and statistics.
% Note: sigma is the vector of the GARCH conditional VOLATILITY, not variance. 
% Compute step by step the vector "sigma"
param(1:4,1)=[coeff.C;coeff.K;coeff.GARCH;coeff.ARCH];
init=param(2)/(1-param(3)-param(4));                                        %This initializes the first value of sigma to equal the unconditional variance
cond_var_garch=NaN(rows(GARCHsigma),1);
cond_var_garch(1)=init;
for i=1:(se-ss)
    cond_var_garch(i+1)=param(2)+param(3)*cond_var_garch(i)+param(4)*(innovation(i)^2);
end
cond_std_garch=sqrt(cond_var_garch);
disp('======================== GARCH(1,1) Forecast ==========================')
% Compute GARCH(1,1) 1-step and n-step ahead forecasts using Garchpred 
spec_pred=garchset('C',coeff.C,'K',coeff.K,'ARCH',coeff.ARCH,'GARCH',coeff.GARCH); % This produces a new garchset specification starting from earlier 
                                                                                   % estimates
garch_1s_for=NaN(se_os-se,1);                                                   % garchpred forecasts ARMAX/GARCH model responses
                                                                            
for i=1:(se_os-se)
    [SigmaForecast,MeanForecast,SigmaTotal,MeanRMSE] = garchpred(spec_pred,Port(ss:se+i-1),1); 
    garch_1s_for(i)=SigmaForecast(1);
end
[SigmaForecast,MeanForecast,SigmaTotal,MeanRMSE] = garchpred(spec_pred,Port(ss:se),Tfor); 
garch_for=SigmaForecast;