disp('=====================  RiskMetrics Esponential Smoother Estimation =====================')

% Maximum Likelihood Estimation
parm=0.1;                                                                   %This sets an initial condition for the estimation (a weird one, indeed)
logL= maxlik('objfunction',parm,[],Port(ss:se));
lambda=logL.b;
disp('The estimated RiskMetrics smoothing coefficient is: ')   
disp(lambda)                                                                %The MLE program is based on the maximization of the log-likelihood given in
                                                                            %objfunction. That procedure reads as
                                                                            %
                                                                            % ret=y;
                                                                            % R=rows(ret);
                                                                            % C=cols(ret);
                                                                            % conditional_var=NaN(R,C);
                                                                            % conditional_var(1,1)=var(ret);
                                                                            % for i=2:R
                                                                            %   conditional_var(i,1)=(1-lambda)*ret(i-1,1).^2+lambda*conditional_var(i-1,1);
                                                                            % end
                                                                            % z=ret./sqrt(conditional_var);
                                                                            % y=-sum(-0.5*log(2*pi)-0.5*log(conditional_var)-0.5*(z.^2));
% Compute step by step the vector "sigma"
cond_var_es=NaN(rows(GARCHsigma),1);
cond_var_es(1)=init;
for i=1:(se-ss) 
    cond_var_es(i+1)=lambda*cond_var_es(i)+(1-lambda)*Port(ss+i-1)^2;
end
cond_std_es=sqrt(cond_var_es);

disp(' RiskMetrics Volatility Forecasts ==================')
% Compute ES 1-step and n-step ahead forecasts
es_1s_for = NaN(se_os-se,1);
es_1s_for(1,1) = cond_var_garch(se-ss+1);

for i=1:(se_os-se-1)
    es_1s_for(i+1)=lambda*es_1s_for(i)+(1-lambda)*Port(se+i-1)^2;
end
es_std_1s_for=sqrt(es_1s_for);

es_for = NaN(se_os-se,1);
es_for(:,1) = cond_var_garch(se-ss+1);
es_std_for=sqrt(es_for);
