disp('=============   Regression of squared returns on Model variances ============')

result = ols((Port(ss:se,:).^2),[ones(se-ss+1,1) (cond_var_garch)]);
disp('Estimated alpha and beta from regression test: GARCH(1,1) Variance forecast:');
disp(result.beta');
disp('With t-stats for the null of alpha=0 and beta=1 of:');
disp([result.tstat(1) ((result.beta(2)-1)/result.bstd(2))]);fprintf('\n');
disp('and an R-square of:');
disp(result.rsqr)

result = ols((Port(ss:se,:).^2),[ones(se-ss+1,1) (cond_var_es)]);
disp('Estimated alpha and beta from regression test: RiskMetrics Variance forecast:');
disp(result.beta');
disp('With t-stats for the null of alpha=0 and beta=1 of:');
disp([result.tstat(1) ((result.beta(2)-1)/result.bstd(2))]);fprintf('\n');
disp('and an R-square of:');
disp(result.rsqr)

result =ols((Port(ss:se,:).^2),[ones(se-ss+1,1) (cond_var_ng)]);
disp('Estimated alpha and beta from regression test: NGARCH(1,1) Variance forecast:');
disp(result.beta');
disp('With t-stats for the null of alpha=0 and beta=1 of:');
disp([result.tstat(1) ((result.beta(2)-1)/result.bstd(2))]);fprintf('\n');
disp('and an R-square of:');
disp(result.rsqr)