z_garch=Port(ss:se,:)./GARCHsigma;
z_gjr=Port(ss:se,:)./GJRsigma;
z_unc=Port(ss:se,:)./(std(Port(ss:se,:)));
run Figure005b.m 
% QQ-Plots: UNC GARCH and  GJR-GARCH 
RET1=[z_unc z_garch z_gjr];
label1=strvcat('UNC','GARCH ', 'GJR-GARCH ');
run Figure006.m
% Jarque-Bera tests
[h,p_val,jbstat,critval] = jbtest(z_unc);
[h_std,p_val_std,jbstat_std,critval_std] = jbtest(z_garch);
col1=strvcat(' ','JB statistic:  ','Critical val:','P-value:','Reject H0?');
col2=strvcat('STD. UNC. RETURNS     ',num2str(jbstat),num2str(critval),num2str(p_val),num2str(h));
col3=strvcat('STD. GJR-GARCH RETURNS ',num2str(jbstat_std),num2str(critval_std),num2str(p_val_std),num2str(h_std));
mat=[col1,col2,col3];
disp(['Jarque-Bera test for normality (5%)']);
disp(mat);fprintf('\n');


% GJR GARCH simulation 
disp('================  -- GARCH with Leverage Simulations  ================')
spec_gjr=garchset('VarianceModel','GJR','P',1,'Q',1,'K',0.05,'GARCH',0.85,'ARCH',0.1,'leverage',0.05);
[param_gjr,errors_gjr,llf_gjr,innovation_gjr,sigmas_gjr,summary_gjr]=garchfit(spec_gjr,Port(ss:se,:));
garchdisp(param_gjr,errors_gjr);
par_gjr_1=garchget(param_gjr,'GARCH'); 
par_gjr_2=garchget(param_gjr,'ARCH'); 
par_gjr_3=garchget(param_gjr,'leverage');
spec_sim=garchset('Distribution','Gaussian','C',0,'VarianceModel','GJR','P',param_gjr.P,'Q',param_gjr.Q,'K',param_gjr.K,'GARCH',param_gjr.GARCH,'ARCH',param_gjr.ARCH,'Leverage',param_gjr.Leverage);
[ret_sim, sigma2_sim]=garchsim(spec_sim,length(z_ng),[]);
z_sim=ret_sim./sigma2_sim;                                                  % garchsim simulates ARMAX/GARCH model responses
                                                                            % Syntax: [Innovations,Sigmas,Series] = garchsim(Spec,NumSamples,NumPaths)
                                                                            % Each path is sampled at NumSamples observations.
                                                                            % Input Arguments:
                                                                            % Spec       GARCH specification structure for the conditional mean and variance 
                                                                            %            models. You create Spec by calling the function garchset or the 
                                                                            %            estimation function garchfit. The conditional mean can be of general 
                                                                            %            ARMAX form and the conditional variance of general GARCH form.
                                                                            % NumSamples Positive integer indicating the number of observations garchsim 
                                                                            %            generates for each path of the Innovations, Sigmas, and Series 
                                                                            %            outputs. If NumSamples = [] or is unspecified, the default is 100.
                                                                            % NumPaths   Positive integer indicating the number of sample paths garchsim 
                                                                            %            generates for the Innovations, Sigmas, and Series outputs. If 
                                                                            %            NumPaths = [] or is unspecified, the default is 1; that is, 
                                                                            %            Innovations, Sigmas and Series are column vectors.
                                                                            % Output Arguments:
                                                                            % Innovations NumSamples by NumPaths matrix of innovations, representing a 
                                                                            %             mean zero, discrete-time stochastic process. The Innovations time 
                                                                            %             series follows the conditional variance specification defined in 
                                                                            %             Spec. Rows are sequential observations, columns are paths.
                                                                            % Sigmas      NumSamples by NumPaths matrix of conditional standard deviations 
                                                                            %             of the corresponding Innovations matrix. Innovations and Sigmas 
                                                                            %             are the same size.
                                                                            % Series      NumSamples by NumPaths matrix of the return series of interest. 
                                                                            %             Series is the dependent stochastic process and follows the 
                                                                            %             conditional mean specification of general ARMAX form defined in 
                                                                            %             Spec. Rows are sequential observations. Columns are paths.
% GJR-GARCH QQ-Plot: Returns vs Standardized Returns
RET2=[ret_sim z_sim];

label=strvcat(' Simulated Returns', ' Simulated Standardized Returns');        %These are useful labels to be applied to the top of your plots
figure;
for i=1:2
    subplot(1,2,i)
    qqplot(RET2(:,i));
    set(gca,'fontname','garamond','fontsize',13);
    set(gcf,'color','w');
    tit=strcat('Question 4: QQ-plot Simulated GJR-GARCH: ',label(i,:));
    title(tit);
    set(gca,'ylim',[-5 5]);
end


% GJR-GARCH JB test: Returns vs Standardized Returns
[h_sim,p_val_sim,jbstat_sim,critval_sim] = jbtest(ret_sim);
[h_sim_std,p_val_sim_std,jbstat_sim_std,critval_sim_std] = jbtest(z_sim);

fprintf('\n');
col1=strvcat(' ','JB statistic:  ','Critical val:','P-value:','Reject H0?');
col2=strvcat('RETURNS (SIM)   ',num2str(jbstat_sim),num2str(critval_sim),num2str(p_val_sim),num2str(h_sim));
col3=strvcat('STD RET (SIM) ',num2str(jbstat_sim_std),num2str(critval_sim_std),num2str(p_val_sim_std),num2str(h_sim_std));
mat=[col1,col2,col3];
disp(['Jarque-Bera test for normality of GJR-GARCH(5%)']);
disp(mat);
fprintf('\n');


% NGARCH simulation 
zt=random('Normal',0,1,length(z_ng),1);                                     %random is the general purpose random number generator in Matlab.
[r_sim,s_sim]=ngarch_sim(param_ng,var(Port(ss:se,:)),zt);       %User-supplied procedure [r_sim,s_sim]=ngarch_sim(par,sig2_0,innov);
                                                                            %Inputs:
                                                                            % par: NGARCH 4x1 parameter vector (omega; alpha; theta; beta)
                                                                            % sig2_0: initial variance
                                                                            % innov: vector of innovations
r_sim=r_sim(2:end,:);  s_sim=s_sim(2:end,:);                                %First observation will be NaN by construction and needs to be purged

% NGARCH QQ-Plot: Returns vs Standardized Returns
RET3=[r_sim zt(2:end,:)];
run Figure007.m