function [coeff,errors,sigma,resid,Rsqr,miu]=regression_tool_1(variance_model, distribution,Y,X,P,Q,n)
% [coeff,errors,sigma,resid,Rsqr,miu]=regression_tool_1(variance_model,
% distribution,Y,X,P,Q,n)

% input n is the number of observations used to estimate the model

% in the output of sigma and miu, (1:n) is implied by the sample and the
% rest is out-of-sample forecast
T=rows(Y);
k=cols(X);
% 1. estimation
spec=garchset('VarianceModel',variance_model,'Distribution',distribution,'C',0,'P',P,'Q',Q,'Regress',zeros(k,1));
[coeff,errors,llf,resid,sigma,summary]=garchfit(spec,Y(1:n),X(1:n,:));

% 2. prediction
if n<T
    [SigmaForecast,MeanForecast] = garchpred(coeff,Y(1:n),T-n,X(1:n,:),X(n+1:end,:));
else
    SigmaForecast=[];
    MeanForecast=[];
end

% 3.output
miu=[Y(1:n)-resid;MeanForecast];
sigma=[sigma;SigmaForecast];
Rsqr=1-sum(resid.^2)/sum(Y(1:n).^2);
